/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { SeriesDescription } from "./SeriesDescription";
import { markType } from "./type";
/**
 * @hidden
 */
export let HighDensityScatterSeriesDescription = /*@__PURE__*/ (() => {
    class HighDensityScatterSeriesDescription extends SeriesDescription {
        get_type() {
            return "HighDensityScatterSeries";
        }
        constructor() {
            super();
            this.ds = null;
            this.dw = null;
            this.dv = null;
            this.dt = null;
            this.dx = null;
            this.du = null;
            this.dy = null;
            this.dz = null;
            this.dd = false;
            this.dc = false;
            this.dh = 0;
            this.dg = 0;
            this.dq = null;
            this.dp = null;
            this.dk = 0;
            this.dl = 0;
            this.dr = null;
        }
        get xAxisRef() {
            return this.ds;
        }
        set xAxisRef(a) {
            this.ds = a;
            this.g("XAxisRef");
        }
        get yAxisRef() {
            return this.dw;
        }
        set yAxisRef(a) {
            this.dw = a;
            this.g("YAxisRef");
        }
        get xMemberPath() {
            return this.dv;
        }
        set xMemberPath(a) {
            this.dv = a;
            this.g("XMemberPath");
        }
        get xMemberAsLegendLabel() {
            return this.dt;
        }
        set xMemberAsLegendLabel(a) {
            this.dt = a;
            this.g("XMemberAsLegendLabel");
        }
        get yMemberAsLegendLabel() {
            return this.dx;
        }
        set yMemberAsLegendLabel(a) {
            this.dx = a;
            this.g("YMemberAsLegendLabel");
        }
        get xMemberAsLegendUnit() {
            return this.du;
        }
        set xMemberAsLegendUnit(a) {
            this.du = a;
            this.g("XMemberAsLegendUnit");
        }
        get yMemberAsLegendUnit() {
            return this.dy;
        }
        set yMemberAsLegendUnit(a) {
            this.dy = a;
            this.g("YMemberAsLegendUnit");
        }
        get yMemberPath() {
            return this.dz;
        }
        set yMemberPath(a) {
            this.dz = a;
            this.g("YMemberPath");
        }
        get useBruteForce() {
            return this.dd;
        }
        set useBruteForce(a) {
            this.dd = a;
            this.g("UseBruteForce");
        }
        get progressiveLoad() {
            return this.dc;
        }
        set progressiveLoad(a) {
            this.dc = a;
            this.g("ProgressiveLoad");
        }
        get heatMinimum() {
            return this.dh;
        }
        set heatMinimum(a) {
            this.dh = a;
            this.g("HeatMinimum");
        }
        get heatMaximum() {
            return this.dg;
        }
        set heatMaximum(a) {
            this.dg = a;
            this.g("HeatMaximum");
        }
        get heatMinimumColor() {
            return this.dq;
        }
        set heatMinimumColor(a) {
            this.dq = a;
            this.g("HeatMinimumColor");
        }
        get heatMaximumColor() {
            return this.dp;
        }
        set heatMaximumColor(a) {
            this.dp = a;
            this.g("HeatMaximumColor");
        }
        get pointExtent() {
            return this.dk;
        }
        set pointExtent(a) {
            this.dk = a;
            this.g("PointExtent");
        }
        get progressiveStatus() {
            return this.dl;
        }
        set progressiveStatus(a) {
            this.dl = a;
            this.g("ProgressiveStatus");
        }
        get progressiveLoadStatusChangedRef() {
            return this.dr;
        }
        set progressiveLoadStatusChangedRef(a) {
            this.dr = a;
            this.g("ProgressiveLoadStatusChangedRef");
        }
    }
    HighDensityScatterSeriesDescription.$t = /*@__PURE__*/ markType(HighDensityScatterSeriesDescription, 'HighDensityScatterSeriesDescription', SeriesDescription.$);
    return HighDensityScatterSeriesDescription;
})();
