import { CaptureImageFormat_$type } from "./CaptureImageFormat";
import { CaptureImageSettings as CaptureImageSettings_internal } from "./CaptureImageSettings";
import { ensureEnum, ensureBool } from "./componentUtil";
var IgrCaptureImageSettings = /** @class */ /*@__PURE__*/ (function () {
    function IgrCaptureImageSettings() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrCaptureImageSettings.prototype.createImplementation = function () {
        return new CaptureImageSettings_internal();
    };
    Object.defineProperty(IgrCaptureImageSettings.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrCaptureImageSettings.prototype.onImplementationCreated = function () {
    };
    IgrCaptureImageSettings.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrCaptureImageSettings.prototype, "format", {
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = ensureEnum(CaptureImageFormat_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCaptureImageSettings.prototype, "addToClipboard", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrCaptureImageSettings.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrCaptureImageSettings;
}());
export { IgrCaptureImageSettings };
