import { Base, Type } from "./type";
import { CodeGenerationTargetPlatforms } from "./CodeGenerationTargetPlatforms";
import { CodeGeneratingRendererResult } from "./CodeGeneratingRendererResult";
import { CodeGenerationRendererOptions } from "./CodeGenerationRendererOptions";
import { CodeGeneratingCodeWriter } from "./CodeGeneratingCodeWriter";
import { CodeGenerationItemBuilderPropertyInfo } from "./CodeGenerationItemBuilderPropertyInfo";
import { List$1 } from "./List$1";
import { TypeDescriptionContext } from "./TypeDescriptionContext";
import { TypeDescriptionMetadata } from "./TypeDescriptionMetadata";
import { DescriptionRef } from "./DescriptionRef";
import { StringBuilder } from "./StringBuilder";
import { CodeGeneratingImportManager } from "./CodeGeneratingImportManager";
import { CodeGenerationLibraryItemContent } from "./CodeGenerationLibraryItemContent";
import { CodeGeneratingComponentRendererHandlerEmitter } from "./CodeGeneratingComponentRendererHandlerEmitter";
import { CodeGeneratingComponentRendererDataEmitter } from "./CodeGeneratingComponentRendererDataEmitter";
import { CodeGeneratingComponentRendererDataEmitterPropertyType } from "./CodeGeneratingComponentRendererDataEmitterPropertyType";
import { CodeGeneratingComponentRendererDataEmitterItemType } from "./CodeGeneratingComponentRendererDataEmitterItemType";
import { CodeGenerationLibraryItemContentLocation } from "./CodeGenerationLibraryItemContentLocation";
import { JsonDictionaryValue } from "./JsonDictionaryValue";
import { JsonDictionaryObject } from "./JsonDictionaryObject";
import { JsonDictionaryItem } from "./JsonDictionaryItem";
import { ComponentRenderer } from "./ComponentRenderer";
import { DescriptionTreeAction } from "./DescriptionTreeAction";
import { CodeGeneratingComponentRendererTemplateEmitter } from "./CodeGeneratingComponentRendererTemplateEmitter";
import { CodeGeneratingComponentRendererModuleEmitter } from "./CodeGeneratingComponentRendererModuleEmitter";
import { ICodeGenerationRendererTemplate } from "./ICodeGenerationRendererTemplate";
import { IComponentRendererAdapter } from "./IComponentRendererAdapter";
/**
 * @hidden
 */
export declare abstract class CodeGeneratingComponentRendererCodeEmitter extends Base {
    static $t: Type;
    private l;
    private j;
    protected get_aj(): string;
    protected get aj(): string;
    protected get_ak(): string;
    protected get ak(): string;
    protected get a4(): string;
    protected get m(): CodeGenerationRendererOptions;
    private z;
    protected bp(a: CodeGenerationItemBuilderPropertyInfo): void;
    protected get k(): CodeGeneratingRendererResult;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    private d;
    protected get h(): CodeGeneratingCodeWriter;
    private a;
    protected get e(): CodeGeneratingCodeWriter;
    private c;
    protected get g(): CodeGeneratingCodeWriter;
    private b;
    protected get f(): CodeGeneratingCodeWriter;
    private aa;
    protected a9(a: string): void;
    protected abstract get r(): boolean;
    w(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): boolean;
    q(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): boolean;
    t(a: CodeGenerationItemBuilderPropertyInfo): boolean;
    private ad;
    protected get ao(): string;
    ba(a: string, b: string, c: TypeDescriptionContext): void;
    u(a: string, b: TypeDescriptionContext): boolean;
    bo(): void;
    bi(a: number): void;
    bj(a: string): void;
    bg(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    bh(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    toString(): string;
    protected ay(): string;
    protected a1(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo, c: boolean): string;
    protected a7(a: any): string;
    protected abstract i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    protected am(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    private al;
    protected ap(a: TypeDescriptionContext, b: CodeGenerationItemBuilder, c: string, d: string): string;
    protected aq(a: CodeGenerationItemBuilderPropertyInfo, b: TypeDescriptionContext, c: List$1<CodeGenerationItemBuilder>, d: List$1<string>, e: string): string;
    protected a6(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    protected ar(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    protected ae(a: CodeGenerationItemBuilderPropertyInfo): any;
    private a0;
    protected s(a: CodeGenerationItemBuilderPropertyInfo): boolean;
    protected az(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected at(a: CodeGenerationItemBuilderPropertyInfo): string;
    private aw;
    protected au(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected ax(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected av(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected get_x(): boolean;
    protected get x(): boolean;
    protected ai(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected ah(a: any): string;
    protected ag(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected af(a: any): string;
    private ab;
    private ac;
    bn(a: string): void;
    bm(a: string): void;
    private as;
    bk(): void;
    protected get_a5(): string;
    protected get a5(): string;
    get an(): string;
    protected get v(): boolean;
    protected get o(): boolean;
    protected get p(): boolean;
    a3: string;
    protected get_y(): boolean;
    get y(): boolean;
    a2: string;
    protected get_n(): boolean;
    get n(): boolean;
    bl(): void;
    bc(a: StringBuilder): void;
    bf(a: StringBuilder): void;
    bb(a: StringBuilder): void;
    bd(a: TypeDescriptionContext, b: CodeGeneratingImportManager): void;
    protected be(a: TypeDescriptionContext, b: List$1<string>, c: CodeGeneratingImportManager): void;
}
/**
 * @hidden
 */
export declare class BlazorRazorCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_r(): boolean;
    protected get r(): boolean;
    protected ap(a: TypeDescriptionContext, b: CodeGenerationItemBuilder, c: string, d: string): string;
    protected aq(a: CodeGenerationItemBuilderPropertyInfo, b: TypeDescriptionContext, c: List$1<CodeGenerationItemBuilder>, d: List$1<string>, e: string): string;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    protected get_y(): boolean;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected bt(a: TypeDescriptionContext, b: string, c: CodeGenerationItemBuilderPropertyInfo): string;
    protected ar(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    ba(a: string, b: string, c: TypeDescriptionContext): void;
    bo(): void;
    bj(a: string): void;
    private bs;
    private bq;
    private br;
    bg(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected au(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected a1(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo, c: boolean): string;
    protected ae(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected ay(): string;
    protected at(a: CodeGenerationItemBuilderPropertyInfo): string;
    private bu;
    protected az(a: CodeGenerationItemBuilderPropertyInfo): string;
    bh(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected get_a5(): string;
}
/**
 * @hidden
 */
export declare class BlazorCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_r(): boolean;
    protected get r(): boolean;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    protected get_y(): boolean;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected bt(a: string, b: CodeGenerationItemBuilderPropertyInfo): string;
    protected ar(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    ba(a: string, b: string, c: TypeDescriptionContext): void;
    bo(): void;
    bj(a: string): void;
    private bs;
    private bq;
    private br;
    bg(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected au(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected a1(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo, c: boolean): string;
    protected ae(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected ay(): string;
    protected at(a: CodeGenerationItemBuilderPropertyInfo): string;
    private bu;
    protected az(a: CodeGenerationItemBuilderPropertyInfo): string;
    bh(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected get_a5(): string;
}
/**
 * @hidden
 */
export declare class ReactMarkupCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_r(): boolean;
    protected get r(): boolean;
    protected ap(a: TypeDescriptionContext, b: CodeGenerationItemBuilder, c: string, d: string): string;
    protected aq(a: CodeGenerationItemBuilderPropertyInfo, b: TypeDescriptionContext, c: List$1<CodeGenerationItemBuilder>, d: List$1<string>, e: string): string;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected ar(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    protected get_x(): boolean;
    protected get_a5(): string;
    private bq;
    private br;
    ba(a: string, b: string, c: TypeDescriptionContext): void;
    private bt;
    bo(): void;
    private bs;
    protected av(a: CodeGenerationItemBuilderPropertyInfo): string;
    bj(a: string): void;
    bg(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected ae(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected ay(): string;
    protected at(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected az(a: CodeGenerationItemBuilderPropertyInfo): string;
    bh(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected be(a: TypeDescriptionContext, b: List$1<string>, c: CodeGeneratingImportManager): void;
}
/**
 * @hidden
 */
export declare abstract class WebCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_r(): boolean;
    protected get r(): boolean;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    private bq;
    protected au(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected ar(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    protected get_x(): boolean;
    ba(a: string, b: string, c: TypeDescriptionContext): void;
    private bu;
    bo(): void;
    bi(a: number): void;
    bj(a: string): void;
    private bt;
    private br;
    private bs;
    bg(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected ae(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected ay(): string;
    protected at(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected az(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected av(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected a1(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo, c: boolean): string;
    bh(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
}
/**
 * @hidden
 */
export declare class ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter extends WebCodeBehindCodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_r(): boolean;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected get_a5(): string;
    protected be(a: TypeDescriptionContext, b: List$1<string>, c: CodeGeneratingImportManager): void;
    bv(a: string, b: TypeDescriptionContext): boolean;
}
/**
 * @hidden
 */
export declare class WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_r(): boolean;
    protected get r(): boolean;
    private bq;
    protected au(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    protected ap(a: TypeDescriptionContext, b: CodeGenerationItemBuilder, c: string, d: string): string;
    protected aq(a: CodeGenerationItemBuilderPropertyInfo, b: TypeDescriptionContext, c: List$1<CodeGenerationItemBuilder>, d: List$1<string>, e: string): string;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected ar(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    protected get_x(): boolean;
    ba(a: string, b: string, c: TypeDescriptionContext): void;
    private bu;
    bo(): void;
    bj(a: string): void;
    private bt;
    private br;
    private bs;
    protected get_a5(): string;
    protected be(a: TypeDescriptionContext, b: List$1<string>, c: CodeGeneratingImportManager): void;
    bg(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected ae(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected ay(): string;
    protected at(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected az(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected av(a: CodeGenerationItemBuilderPropertyInfo): string;
    bh(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
}
/**
 * @hidden
 */
export declare class WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter extends WebCodeBehindCodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected get_a5(): string;
    protected be(a: TypeDescriptionContext, b: List$1<string>, c: CodeGeneratingImportManager): void;
}
/**
 * @hidden
 */
export declare class TSCodeGeneratingComponentRendererHandlerEmitter extends CodeGeneratingComponentRendererHandlerEmitter {
    static $t: Type;
    private w;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult, c: CodeGenerationTargetPlatforms);
    protected t(a: string, b: boolean): void;
    protected u(a: string, b: boolean): void;
    protected get z(): string;
    protected get aa(): string;
    protected v(a: CodeGeneratingImportManager, b: string): void;
    protected get_y(): string;
    protected get y(): string;
    protected get_x(): string;
    protected get x(): string;
    protected q(a: string, b: string): string;
}
/**
 * @hidden
 */
export declare class TSCodeGeneratingComponentRendererDataEmitter extends CodeGeneratingComponentRendererDataEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected w(a: string, b?: boolean): string;
    protected v(a: string): string;
    protected ap(a: string): string;
    protected get_s(): string;
    private al;
    protected ak(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: CodeGeneratingCodeWriter, e: CodeGeneratingImportManager): void;
    protected ag(a: string, b: CodeGenerationLibraryItemContentLocation, c: CodeGenerationLibraryItemContent): void;
    protected ah(a: string, b: JsonDictionaryValue): void;
    protected ai(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: JsonDictionaryObject): void;
    protected y(a: string, b: CodeGeneratingImportManager): void;
    protected z(a: string, b: string, c: CodeGeneratingImportManager): void;
    protected aa(a: string, b: CodeGeneratingImportManager): void;
    protected ac(a: CodeGeneratingComponentRendererDataEmitterItemType, b: CodeGeneratingCodeWriter, c: CodeGeneratingImportManager): void;
    private am;
    private ao;
    protected aj(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: CodeGeneratingCodeWriter): void;
    protected x(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: JsonDictionaryItem, e: number, f: CodeGeneratingCodeWriter): void;
    private aq;
    protected t(a: CodeGeneratingComponentRendererDataEmitterPropertyType, b: JsonDictionaryValue): string;
    protected an(a: JsonDictionaryValue): string;
}
/**
 * @hidden
 */
export declare class AngularTemplateCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_r(): boolean;
    protected get r(): boolean;
    protected ap(a: TypeDescriptionContext, b: CodeGenerationItemBuilder, c: string, d: string): string;
    protected aq(a: CodeGenerationItemBuilderPropertyInfo, b: TypeDescriptionContext, c: List$1<CodeGenerationItemBuilder>, d: List$1<string>, e: string): string;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected ar(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    protected get_x(): boolean;
    protected get_a5(): string;
    private bs;
    private bq;
    private br;
    ba(a: string, b: string, c: TypeDescriptionContext): void;
    protected be(a: TypeDescriptionContext, b: List$1<string>, c: CodeGeneratingImportManager): void;
    private bt;
    bo(): void;
    bj(a: string): void;
    bg(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected av(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected ae(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected ay(): string;
    protected at(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected az(a: CodeGenerationItemBuilderPropertyInfo): string;
    bh(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
}
/**
 * @hidden
 */
export declare class AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter extends WebCodeBehindCodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_r(): boolean;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected get_a5(): string;
    protected be(a: TypeDescriptionContext, b: List$1<string>, c: CodeGeneratingImportManager): void;
}
/**
 * @hidden
 */
export declare class DotNetCodeGeneratingComponentRendererDataEmitter extends CodeGeneratingComponentRendererDataEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected aa(a: string, b: CodeGeneratingImportManager): void;
    protected ae(a: CodeGeneratingCodeWriter): void;
    private al;
    protected ad(a: CodeGeneratingCodeWriter): void;
    protected w(a: string, b?: boolean): string;
    protected v(a: string): string;
    protected ap(a: string): string;
    protected ak(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: CodeGeneratingCodeWriter, e: CodeGeneratingImportManager): void;
    protected ag(a: string, b: CodeGenerationLibraryItemContentLocation, c: CodeGenerationLibraryItemContent): void;
    protected ah(a: string, b: JsonDictionaryValue): void;
    protected ai(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: JsonDictionaryObject): void;
    protected get_s(): string;
    protected ac(a: CodeGeneratingComponentRendererDataEmitterItemType, b: CodeGeneratingCodeWriter, c: CodeGeneratingImportManager): void;
    private am;
    private ao;
    protected aj(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: CodeGeneratingCodeWriter): void;
    protected x(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: JsonDictionaryItem, e: number, f: CodeGeneratingCodeWriter): void;
    private aq;
    protected t(a: CodeGeneratingComponentRendererDataEmitterPropertyType, b: JsonDictionaryValue): string;
    protected an(a: JsonDictionaryValue): string;
}
/**
 * @hidden
 */
export declare class WPFXamlCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected a7(a: any): string;
    protected get_r(): boolean;
    protected get r(): boolean;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    protected get_y(): boolean;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected ar(a: TypeDescriptionContext, b: CodeGenerationItemBuilderPropertyInfo): string;
    ba(a: string, b: string, c: TypeDescriptionContext): void;
    bo(): void;
    bj(a: string): void;
    bg(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected ae(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected ay(): string;
    protected at(a: CodeGenerationItemBuilderPropertyInfo): string;
    private bq;
    protected az(a: CodeGenerationItemBuilderPropertyInfo): string;
    bh(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected get_a5(): string;
}
/**
 * @hidden
 */
export declare class WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected a7(a: any): string;
    protected get_r(): boolean;
    protected get r(): boolean;
    protected i(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    protected get_y(): boolean;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
}
/**
 * @hidden
 */
export declare class CodeGeneratingComponentRenderer extends ComponentRenderer {
    static $t: Type;
    loadCodeJson(a: string): void;
    protected cw(a: boolean): void;
    protected n(): boolean;
    static d4(a: string): string;
    static d6(a: string): string;
    static d5(a: string): string;
    static d7(a: string): string;
    protected aq(): boolean;
    bo(a: DescriptionTreeAction): any;
    bp(a: DescriptionTreeAction): any;
    bq(a: DescriptionTreeAction): any;
    bs(a: DescriptionTreeAction): any;
    protected b6(a: string): any;
    protected b7(a: string): any;
    ad(a: JsonDictionaryItem): boolean;
    ak(a: JsonDictionaryItem): boolean;
    ae(a: JsonDictionaryItem): boolean;
    af(a: JsonDictionaryItem): boolean;
    ag(a: JsonDictionaryItem): boolean;
    dq(a: CodeGenerationItemBuilder, b: CodeGenerationRendererOptions, c: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    dr(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererDataEmitter;
    ds(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererHandlerEmitter;
    du(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererTemplateEmitter;
    dt(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererModuleEmitter;
    emitCode(a: ICodeGenerationRendererTemplate): CodeGeneratingRendererResult;
    private eb;
    protected bb(): (arg1: string) => string;
    private d8;
    private d9;
    private dw;
    private dx;
    private d0;
    private d1;
    private d2;
    private dz;
    private dy;
    constructor(a: CodeGenerationTargetPlatforms, b: CodeGenerationRendererOptions);
    private static d3;
}
/**
 * @hidden
 */
export declare class CodeGenerationContainer extends Base {
    static $t: Type;
    private _id;
    get id(): string;
    set id(a: string);
    constructor();
    a: List$1<CodeGenerationItemBuilder>;
    c(a: TypeDescriptionContext, b: CodeGeneratingRendererResult, c: CodeGeneratingComponentRenderer, d: CodeGenerationRendererOptions): void;
}
/**
 * @hidden
 */
export declare class CodeGenerationItemBuilder extends Base {
    static $t: Type;
    private g;
    private f;
    private c;
    private b;
    private j;
    private h;
    o(): string;
    constructor(a: CodeGenerationTargetPlatforms, b: string, c: TypeDescriptionContext, d: any);
    a(a: string): CodeGenerationItemBuilder;
    r(a: TypeDescriptionMetadata): string;
    x(a: string, b: TypeDescriptionMetadata, c: any, d: DescriptionRef): void;
    v(a: string, b: TypeDescriptionMetadata, c: DescriptionRef): void;
    w(a: string, b: TypeDescriptionMetadata): void;
    i(a: string): any;
    t: string;
    u(a: CodeGeneratingComponentRendererCodeEmitter, b: boolean): void;
    protected e(a: TypeDescriptionContext, b: CodeGeneratingComponentRendererCodeEmitter): boolean;
    private d;
    q(): string;
    protected get s(): string;
    static n(a: CodeGenerationTargetPlatforms, b: string, c: TypeDescriptionContext, d: string, e: string): string;
    m(): string;
    private p;
    protected get_k(): string;
    protected get k(): string;
    protected get_l(): string;
    protected get l(): string;
}
/**
 * @hidden
 */
export declare class CodeGenerationRendererAdapter extends Base implements IComponentRendererAdapter {
    static $t: Type;
    private a;
    private b;
    constructor(a: CodeGenerationTargetPlatforms, b: IComponentRendererAdapter);
    createColorCollection(a: any[]): any;
    createBrushCollection(a: any[]): any;
    createDoubleCollection(a: any[]): any;
    createObject(a: string, b: any, c: TypeDescriptionContext): any;
    coerceToEnum(a: string, b: TypeDescriptionContext, c: string): any;
    onUIThread(a: any, b: () => void): void;
    setOrUpdateCollectionOnTarget(a: any, b: string, c: TypeDescriptionMetadata, d: TypeDescriptionContext, e: any, f: any): void;
    private c;
    onPendingRef(a: any, b: string, c: TypeDescriptionMetadata, d: DescriptionRef): void;
    setPropertyValue(a: any, b: string, c: TypeDescriptionMetadata, d: any, e: any, f: DescriptionRef): void;
    getPropertyValue(a: any, b: string): any;
    getRootObject(a: any): any;
    clearContainer(a: any, b: TypeDescriptionContext, c: (arg1: boolean) => void): void;
    forPropertyValueItem(a: any, b: string, c: (arg1: any) => void): void;
    clearCollection(a: any, b: string, c: TypeDescriptionMetadata): void;
    addItemToCollection(a: string, b: TypeDescriptionMetadata, c: any, d: number, e: any): void;
    resetPropertyOnTarget(a: any, b: string, c: TypeDescriptionMetadata, d: any): void;
    replaceItemInCollection(a: string, b: TypeDescriptionMetadata, c: any, d: number, e: any): void;
    replaceRootItem(a: any, b: string, c: TypeDescriptionContext, d: (arg1: boolean) => void): void;
    removeItemFromCollection(a: string, b: TypeDescriptionMetadata, c: any, d: number): void;
    removeRootItem(a: any, b: TypeDescriptionContext, c: (arg1: boolean) => void): void;
    flushChanges(a: any): void;
}
