import { Base, Type } from "./type";
import { IComponentRendererAdapter } from "./IComponentRendererAdapter";
import { TypeDescriptionContext } from "./TypeDescriptionContext";
import { ITypeDescriptionPropertyTransforms } from "./ITypeDescriptionPropertyTransforms";
import { TypeDescriptionCleanups } from "./TypeDescriptionCleanups";
import { Dictionary$2 } from "./Dictionary$2";
import { Description } from "./Description";
import { DescriptionTreeNode } from "./DescriptionTreeNode";
import { DescriptionTreeAction } from "./DescriptionTreeAction";
import { DescriptionRef } from "./DescriptionRef";
import { TypeDescriptionPlatform } from "./TypeDescriptionPlatform";
import { JsonDictionaryItem } from "./JsonDictionaryItem";
import { DescriptionRefTargetInfo } from "./DescriptionRefTargetInfo";
/**
 * @hidden
 */
export declare class ComponentRenderer extends Base {
    static $t: Type;
    private static _defaultInstance;
    static get defaultInstance(): ComponentRenderer;
    static set defaultInstance(a: ComponentRenderer);
    private _adapter;
    get adapter(): IComponentRendererAdapter;
    set adapter(a: IComponentRendererAdapter);
    private _context;
    get context(): TypeDescriptionContext;
    set context(a: TypeDescriptionContext);
    private _isProceedOnErrorEnabled;
    get isProceedOnErrorEnabled(): boolean;
    set isProceedOnErrorEnabled(a: boolean);
    i: ITypeDescriptionPropertyTransforms;
    j: TypeDescriptionCleanups;
    static platform: TypeDescriptionPlatform;
    constructor();
    private h;
    toJson(a: (arg1: any) => string): string;
    private dj;
    private dk;
    private x;
    private u;
    private di;
    private o;
    createObjectFromJson(a: string, b: any): any;
    loadJson(a: string, b: (arg1: string) => any): void;
    loadJsonOverlay(a: string, b: (arg1: string) => any, c: (arg1: string) => any): void;
    loadJsonDelta(a: string, b: (arg1: string) => any, c: boolean): void;
    private _preserveKeyOrder;
    get preserveKeyOrder(): boolean;
    set preserveKeyOrder(a: boolean);
    protected aq(): boolean;
    protected cw(a: boolean): void;
    private cu;
    provideRefValueFromJson(a: any, b: string, c: string): void;
    protected bb(): (arg1: string) => string;
    ag(a: JsonDictionaryItem): boolean;
    ad(a: JsonDictionaryItem): boolean;
    ak(a: JsonDictionaryItem): boolean;
    ae(a: JsonDictionaryItem): boolean;
    af(a: JsonDictionaryItem): boolean;
    private b9;
    private cq;
    private cr;
    private cd;
    private cb;
    private a;
    private bv;
    private ax;
    private ay;
    private az;
    private aw;
    private au;
    private a2;
    get a6(): Dictionary$2<any, ContainerState>;
    private a0;
    private av;
    private at;
    private a1;
    private a3;
    private a5;
    cleanup(a: any, b: boolean): void;
    render(a: Description, b: any): void;
    private df;
    private cx;
    private dd;
    provideRefValue(a: any, b: string, c: any): void;
    removeRefValue(a: any, b: string): void;
    private db;
    clearRefValues(a: any): void;
    private v;
    queueForIdle(a: any, b: () => void): void;
    tryFlushIdleActions(a: any): void;
    private de;
    private dh;
    private dn;
    private cp;
    private cy;
    private cz;
    private aa;
    private al;
    private as;
    private ca;
    private b8;
    private ce;
    private ap;
    private by;
    private bt;
    private bu;
    bs(a: DescriptionTreeAction): any;
    private br;
    bq(a: DescriptionTreeAction): any;
    bp(a: DescriptionTreeAction): any;
    bo(a: DescriptionTreeAction): any;
    private bn;
    e(a: string, b: ContainerState): DescriptionRef;
    private b4;
    private bm;
    private b3;
    private bj;
    private b2;
    private b5;
    protected b7(a: string): any;
    private bi;
    private bh;
    private bg;
    private bk;
    protected b6(a: string): any;
    private bf;
    private be;
    private a9;
    addTargetPropertyUpdatingListener(a: (propertyPath: string, target: any, newValue: any) => boolean): void;
    removeTargetPropertyUpdatingListener(a: (propertyPath: string, target: any, newValue: any) => boolean): void;
    private a4;
    addPropertyUpdatingListener(a: string, b: (propertyName: string, target: any, newValue: any) => void): void;
    private a7;
    addReferenceLookupListener(a: (container: any, refType: string, id: string) => any): void;
    removeReferenceLookupListener(a: (container: any, refType: string, id: string) => any): void;
    removePropertyUpdatingListener(a: string, b: (propertyName: string, target: any, newValue: any) => void): void;
    private a8;
    addNamespaceLookupListener(a: (container: any) => string): void;
    removeNamespaceLookupListener(a: (container: any) => string): void;
    private bd;
    private dl;
    hasUserRef(a: string): boolean;
    private _shouldNamespaceSystemRefValues;
    get shouldNamespaceSystemRefValues(): boolean;
    set shouldNamespaceSystemRefValues(a: boolean);
    c1(a: any, b: string, c: any, d: boolean): void;
    removeRefValueCore(a: any, b: string, c: boolean): void;
    clearUserRefValues(): void;
    s(a: DescriptionRef): boolean;
    b0(a: DescriptionRef): any;
    r(a: string): boolean;
    f(a: string): DescriptionRef;
    getMissingRefs(): string[];
    getRefChangeInfos(a: string): DescriptionRefTargetInfo[];
    private b1;
    private aj;
    private ao;
    private ai;
    private dg;
    private an;
    co(a: any, b: any, c: ContainerState): void;
    private bc;
    private ah;
    private c4;
    private am;
    private ac;
    private m;
    private cf;
    private bw;
    private w;
    private bl;
    protected n(): boolean;
    private ba;
    private ab;
    private cl;
    private dm;
    private bz;
    private q;
    private p;
}
/**
 * @hidden
 */
export declare class ContainerState extends Base {
    static $t: Type;
    i: any;
    private e;
    private f;
    private d;
    private g;
    private c;
    k(a: any, b: number, c: any, d: DescriptionTreeNode, e: (arg1: any, arg2: string, arg3: any, arg4: boolean) => void, f: number): void;
    a(a: number): boolean;
    b(a: any): boolean;
    j(a: number): any;
    l(a: ComponentRenderer, b: any, c: number, d: (arg1: any, arg2: string, arg3: boolean) => void): void;
    h(a: any): number;
}
