import { Description } from "./Description";
import { FormatSpecifierDescription } from "./FormatSpecifierDescription";
import { ChartSortDescriptionDescription } from "./ChartSortDescriptionDescription";
import { FilterExpressionDescription } from "./FilterExpressionDescription";
import { ChartSummaryDescriptionDescription } from "./ChartSummaryDescriptionDescription";
import { BaseDataSourceDescription } from "./BaseDataSourceDescription";
import { RectDescription } from "./RectDescription";
import { Type } from "./type";
/**
 * @hidden
 */
export declare abstract class DomainChartDescription extends Description {
    static $t: Type;
    protected get_type(): string;
    get type(): string;
    constructor();
    private ei;
    get pixelScalingRatio(): number;
    set pixelScalingRatio(a: number);
    private ev;
    get titleLeftMargin(): number;
    set titleLeftMargin(a: number);
    private ew;
    get titleRightMargin(): number;
    set titleRightMargin(a: number);
    private ex;
    get titleTopMargin(): number;
    set titleTopMargin(a: number);
    private eu;
    get titleBottomMargin(): number;
    set titleBottomMargin(a: number);
    private eq;
    get subtitleLeftMargin(): number;
    set subtitleLeftMargin(a: number);
    private es;
    get subtitleTopMargin(): number;
    set subtitleTopMargin(a: number);
    private er;
    get subtitleRightMargin(): number;
    set subtitleRightMargin(a: number);
    private ep;
    get subtitleBottomMargin(): number;
    set subtitleBottomMargin(a: number);
    private lf;
    get subtitleTextColor(): string;
    set subtitleTextColor(a: string);
    private li;
    get titleTextColor(): string;
    set titleTextColor(a: string);
    private ef;
    get leftMargin(): number;
    set leftMargin(a: number);
    private ey;
    get topMargin(): number;
    set topMargin(a: number);
    private eo;
    get rightMargin(): number;
    set rightMargin(a: number);
    private co;
    get bottomMargin(): number;
    set bottomMargin(a: number);
    private h6;
    get transitionDuration(): number;
    set transitionDuration(a: number);
    private ll;
    get transitionEasingFunctionRef(): string;
    set transitionEasingFunctionRef(a: string);
    private lg;
    get subtitleTextStyle(): string;
    set subtitleTextStyle(a: string);
    private lj;
    get titleTextStyle(): string;
    set titleTextStyle(a: string);
    private i2;
    get dataToolTipGroupingMode(): string;
    set dataToolTipGroupingMode(a: string);
    private da;
    get dataToolTipPositionOffsetX(): number;
    set dataToolTipPositionOffsetX(a: number);
    private db;
    get dataToolTipPositionOffsetY(): number;
    set dataToolTipPositionOffsetY(a: number);
    private cu;
    get dataToolTipDefaultPositionOffsetX(): number;
    set dataToolTipDefaultPositionOffsetX(a: number);
    private cv;
    get dataToolTipDefaultPositionOffsetY(): number;
    set dataToolTipDefaultPositionOffsetY(a: number);
    private i0;
    get dataToolTipGroupedPositionModeX(): string;
    set dataToolTipGroupedPositionModeX(a: string);
    private i1;
    get dataToolTipGroupedPositionModeY(): string;
    set dataToolTipGroupedPositionModeY(a: string);
    private bn;
    get dataToolTipShouldUpdateWhenSeriesDataChanges(): boolean;
    set dataToolTipShouldUpdateWhenSeriesDataChanges(a: boolean);
    private p;
    get dataToolTipIncludedSeries(): string[];
    set dataToolTipIncludedSeries(a: string[]);
    private m;
    get dataToolTipExcludedSeries(): string[];
    set dataToolTipExcludedSeries(a: string[]);
    private o;
    get dataToolTipIncludedColumns(): string[];
    set dataToolTipIncludedColumns(a: string[]);
    private l;
    get dataToolTipExcludedColumns(): string[];
    set dataToolTipExcludedColumns(a: string[]);
    private kb;
    get dataToolTipValueFormatAbbreviation(): string;
    set dataToolTipValueFormatAbbreviation(a: string);
    private h2;
    get dataToolTipValueFormatMaxFractions(): number;
    set dataToolTipValueFormatMaxFractions(a: number);
    private h3;
    get dataToolTipValueFormatMinFractions(): number;
    set dataToolTipValueFormatMinFractions(a: number);
    private kd;
    get dataToolTipValueFormatMode(): string;
    set dataToolTipValueFormatMode(a: string);
    private kc;
    get dataToolTipValueFormatCulture(): string;
    set dataToolTipValueFormatCulture(a: string);
    private bo;
    get dataToolTipValueFormatUseGrouping(): boolean;
    set dataToolTipValueFormatUseGrouping(a: boolean);
    private ke;
    get dataToolTipValueFormatString(): string;
    set dataToolTipValueFormatString(a: string);
    private q;
    get dataToolTipValueFormatSpecifiers(): FormatSpecifierDescription[];
    set dataToolTipValueFormatSpecifiers(a: FormatSpecifierDescription[]);
    private dz;
    get dataToolTipValueRowMarginBottom(): number;
    set dataToolTipValueRowMarginBottom(a: number);
    private d0;
    get dataToolTipValueRowMarginLeft(): number;
    set dataToolTipValueRowMarginLeft(a: number);
    private d1;
    get dataToolTipValueRowMarginRight(): number;
    set dataToolTipValueRowMarginRight(a: number);
    private d2;
    get dataToolTipValueRowMarginTop(): number;
    set dataToolTipValueRowMarginTop(a: number);
    private bp;
    get dataToolTipValueRowVisible(): boolean;
    set dataToolTipValueRowVisible(a: boolean);
    private kj;
    get dataToolTipValueTextWhenMissingData(): string;
    set dataToolTipValueTextWhenMissingData(a: string);
    private bq;
    get dataToolTipValueTextUseSeriesColors(): boolean;
    set dataToolTipValueTextUseSeriesColors(a: boolean);
    private d4;
    get dataToolTipValueTextMarginBottom(): number;
    set dataToolTipValueTextMarginBottom(a: number);
    private d5;
    get dataToolTipValueTextMarginLeft(): number;
    set dataToolTipValueTextMarginLeft(a: number);
    private d6;
    get dataToolTipValueTextMarginRight(): number;
    set dataToolTipValueTextMarginRight(a: number);
    private d7;
    get dataToolTipValueTextMarginTop(): number;
    set dataToolTipValueTextMarginTop(a: number);
    private kf;
    get dataToolTipValueTextColor(): string;
    set dataToolTipValueTextColor(a: string);
    private kg;
    get dataToolTipValueTextFontFamily(): string;
    set dataToolTipValueTextFontFamily(a: string);
    private d3;
    get dataToolTipValueTextFontSize(): number;
    set dataToolTipValueTextFontSize(a: number);
    private kh;
    get dataToolTipValueTextFontStyle(): string;
    set dataToolTipValueTextFontStyle(a: string);
    private ki;
    get dataToolTipValueTextFontWeight(): string;
    set dataToolTipValueTextFontWeight(a: string);
    private i5;
    get dataToolTipHeaderFormatString(): string;
    set dataToolTipHeaderFormatString(a: string);
    private n;
    get dataToolTipHeaderFormatSpecifiers(): FormatSpecifierDescription[];
    set dataToolTipHeaderFormatSpecifiers(a: FormatSpecifierDescription[]);
    private i3;
    get dataToolTipHeaderFormatCulture(): string;
    set dataToolTipHeaderFormatCulture(a: string);
    private i4;
    get dataToolTipHeaderFormatDate(): string;
    set dataToolTipHeaderFormatDate(a: string);
    private i6;
    get dataToolTipHeaderFormatTime(): string;
    set dataToolTipHeaderFormatTime(a: string);
    private i7;
    get dataToolTipHeaderText(): string;
    set dataToolTipHeaderText(a: string);
    private i8;
    get dataToolTipHeaderTextColor(): string;
    set dataToolTipHeaderTextColor(a: string);
    private c1;
    get dataToolTipHeaderTextMarginBottom(): number;
    set dataToolTipHeaderTextMarginBottom(a: number);
    private c2;
    get dataToolTipHeaderTextMarginLeft(): number;
    set dataToolTipHeaderTextMarginLeft(a: number);
    private c3;
    get dataToolTipHeaderTextMarginRight(): number;
    set dataToolTipHeaderTextMarginRight(a: number);
    private c4;
    get dataToolTipHeaderTextMarginTop(): number;
    set dataToolTipHeaderTextMarginTop(a: number);
    private cw;
    get dataToolTipHeaderRowMarginBottom(): number;
    set dataToolTipHeaderRowMarginBottom(a: number);
    private cx;
    get dataToolTipHeaderRowMarginLeft(): number;
    set dataToolTipHeaderRowMarginLeft(a: number);
    private cy;
    get dataToolTipHeaderRowMarginRight(): number;
    set dataToolTipHeaderRowMarginRight(a: number);
    private cz;
    get dataToolTipHeaderRowMarginTop(): number;
    set dataToolTipHeaderRowMarginTop(a: number);
    private bm;
    get dataToolTipHeaderRowVisible(): boolean;
    set dataToolTipHeaderRowVisible(a: boolean);
    private i9;
    get dataToolTipHeaderTextFontFamily(): string;
    set dataToolTipHeaderTextFontFamily(a: string);
    private c0;
    get dataToolTipHeaderTextFontSize(): number;
    set dataToolTipHeaderTextFontSize(a: number);
    private ja;
    get dataToolTipHeaderTextFontStyle(): string;
    set dataToolTipHeaderTextFontStyle(a: string);
    private jb;
    get dataToolTipHeaderTextFontWeight(): string;
    set dataToolTipHeaderTextFontWeight(a: string);
    private jn;
    get dataToolTipSummaryTitleTextColor(): string;
    set dataToolTipSummaryTitleTextColor(a: string);
    private jo;
    get dataToolTipSummaryTitleTextFontFamily(): string;
    set dataToolTipSummaryTitleTextFontFamily(a: string);
    private dh;
    get dataToolTipSummaryTitleTextFontSize(): number;
    set dataToolTipSummaryTitleTextFontSize(a: number);
    private jp;
    get dataToolTipSummaryTitleTextFontStyle(): string;
    set dataToolTipSummaryTitleTextFontStyle(a: string);
    private jq;
    get dataToolTipSummaryTitleTextFontWeight(): string;
    set dataToolTipSummaryTitleTextFontWeight(a: string);
    private jr;
    get dataToolTipSummaryType(): string;
    set dataToolTipSummaryType(a: string);
    private jm;
    get dataToolTipSummaryTitleText(): string;
    set dataToolTipSummaryTitleText(a: string);
    private di;
    get dataToolTipSummaryTitleTextMarginBottom(): number;
    set dataToolTipSummaryTitleTextMarginBottom(a: number);
    private dj;
    get dataToolTipSummaryTitleTextMarginLeft(): number;
    set dataToolTipSummaryTitleTextMarginLeft(a: number);
    private dk;
    get dataToolTipSummaryTitleTextMarginRight(): number;
    set dataToolTipSummaryTitleTextMarginRight(a: number);
    private dl;
    get dataToolTipSummaryTitleTextMarginTop(): number;
    set dataToolTipSummaryTitleTextMarginTop(a: number);
    private dd;
    get dataToolTipSummaryRowMarginBottom(): number;
    set dataToolTipSummaryRowMarginBottom(a: number);
    private de;
    get dataToolTipSummaryRowMarginLeft(): number;
    set dataToolTipSummaryRowMarginLeft(a: number);
    private df;
    get dataToolTipSummaryRowMarginRight(): number;
    set dataToolTipSummaryRowMarginRight(a: number);
    private dg;
    get dataToolTipSummaryRowMarginTop(): number;
    set dataToolTipSummaryRowMarginTop(a: number);
    private jx;
    get dataToolTipSummaryValueTextColor(): string;
    set dataToolTipSummaryValueTextColor(a: string);
    private jy;
    get dataToolTipSummaryValueTextFontFamily(): string;
    set dataToolTipSummaryValueTextFontFamily(a: string);
    private dn;
    get dataToolTipSummaryValueTextFontSize(): number;
    set dataToolTipSummaryValueTextFontSize(a: number);
    private jz;
    get dataToolTipSummaryValueTextFontStyle(): string;
    set dataToolTipSummaryValueTextFontStyle(a: string);
    private j0;
    get dataToolTipSummaryValueTextFontWeight(): string;
    set dataToolTipSummaryValueTextFontWeight(a: string);
    private jh;
    get dataToolTipSummaryLabelText(): string;
    set dataToolTipSummaryLabelText(a: string);
    private ji;
    get dataToolTipSummaryLabelTextColor(): string;
    set dataToolTipSummaryLabelTextColor(a: string);
    private jj;
    get dataToolTipSummaryLabelTextFontFamily(): string;
    set dataToolTipSummaryLabelTextFontFamily(a: string);
    private dc;
    get dataToolTipSummaryLabelTextFontSize(): number;
    set dataToolTipSummaryLabelTextFontSize(a: number);
    private jk;
    get dataToolTipSummaryLabelTextFontStyle(): string;
    set dataToolTipSummaryLabelTextFontStyle(a: string);
    private jl;
    get dataToolTipSummaryLabelTextFontWeight(): string;
    set dataToolTipSummaryLabelTextFontWeight(a: string);
    private js;
    get dataToolTipSummaryUnitsText(): string;
    set dataToolTipSummaryUnitsText(a: string);
    private jt;
    get dataToolTipSummaryUnitsTextColor(): string;
    set dataToolTipSummaryUnitsTextColor(a: string);
    private ju;
    get dataToolTipSummaryUnitsTextFontFamily(): string;
    set dataToolTipSummaryUnitsTextFontFamily(a: string);
    private dm;
    get dataToolTipSummaryUnitsTextFontSize(): number;
    set dataToolTipSummaryUnitsTextFontSize(a: number);
    private jv;
    get dataToolTipSummaryUnitsTextFontStyle(): string;
    set dataToolTipSummaryUnitsTextFontStyle(a: string);
    private jw;
    get dataToolTipSummaryUnitsTextFontWeight(): string;
    set dataToolTipSummaryUnitsTextFontWeight(a: string);
    private cq;
    get dataToolTipBadgeMarginBottom(): number;
    set dataToolTipBadgeMarginBottom(a: number);
    private cr;
    get dataToolTipBadgeMarginLeft(): number;
    set dataToolTipBadgeMarginLeft(a: number);
    private cs;
    get dataToolTipBadgeMarginRight(): number;
    set dataToolTipBadgeMarginRight(a: number);
    private ct;
    get dataToolTipBadgeMarginTop(): number;
    set dataToolTipBadgeMarginTop(a: number);
    private iz;
    get dataToolTipBadgeShape(): string;
    set dataToolTipBadgeShape(a: string);
    private j5;
    get dataToolTipUnitsDisplayMode(): string;
    set dataToolTipUnitsDisplayMode(a: string);
    private j6;
    get dataToolTipUnitsText(): string;
    set dataToolTipUnitsText(a: string);
    private j7;
    get dataToolTipUnitsTextColor(): string;
    set dataToolTipUnitsTextColor(a: string);
    private dv;
    get dataToolTipUnitsTextMarginBottom(): number;
    set dataToolTipUnitsTextMarginBottom(a: number);
    private dw;
    get dataToolTipUnitsTextMarginLeft(): number;
    set dataToolTipUnitsTextMarginLeft(a: number);
    private dx;
    get dataToolTipUnitsTextMarginRight(): number;
    set dataToolTipUnitsTextMarginRight(a: number);
    private dy;
    get dataToolTipUnitsTextMarginTop(): number;
    set dataToolTipUnitsTextMarginTop(a: number);
    private j8;
    get dataToolTipUnitsTextFontFamily(): string;
    set dataToolTipUnitsTextFontFamily(a: string);
    private du;
    get dataToolTipUnitsTextFontSize(): number;
    set dataToolTipUnitsTextFontSize(a: number);
    private j9;
    get dataToolTipUnitsTextFontStyle(): string;
    set dataToolTipUnitsTextFontStyle(a: string);
    private ka;
    get dataToolTipUnitsTextFontWeight(): string;
    set dataToolTipUnitsTextFontWeight(a: string);
    private dq;
    get dataToolTipTitleTextMarginBottom(): number;
    set dataToolTipTitleTextMarginBottom(a: number);
    private dr;
    get dataToolTipTitleTextMarginLeft(): number;
    set dataToolTipTitleTextMarginLeft(a: number);
    private ds;
    get dataToolTipTitleTextMarginRight(): number;
    set dataToolTipTitleTextMarginRight(a: number);
    private dt;
    get dataToolTipTitleTextMarginTop(): number;
    set dataToolTipTitleTextMarginTop(a: number);
    private j1;
    get dataToolTipTitleTextColor(): string;
    set dataToolTipTitleTextColor(a: string);
    private j2;
    get dataToolTipTitleTextFontFamily(): string;
    set dataToolTipTitleTextFontFamily(a: string);
    private dp;
    get dataToolTipTitleTextFontSize(): number;
    set dataToolTipTitleTextFontSize(a: number);
    private j3;
    get dataToolTipTitleTextFontStyle(): string;
    set dataToolTipTitleTextFontStyle(a: string);
    private j4;
    get dataToolTipTitleTextFontWeight(): string;
    set dataToolTipTitleTextFontWeight(a: string);
    private jc;
    get dataToolTipLabelDisplayMode(): string;
    set dataToolTipLabelDisplayMode(a: string);
    private jd;
    get dataToolTipLabelTextColor(): string;
    set dataToolTipLabelTextColor(a: string);
    private c6;
    get dataToolTipLabelTextMarginBottom(): number;
    set dataToolTipLabelTextMarginBottom(a: number);
    private c7;
    get dataToolTipLabelTextMarginLeft(): number;
    set dataToolTipLabelTextMarginLeft(a: number);
    private c8;
    get dataToolTipLabelTextMarginRight(): number;
    set dataToolTipLabelTextMarginRight(a: number);
    private c9;
    get dataToolTipLabelTextMarginTop(): number;
    set dataToolTipLabelTextMarginTop(a: number);
    private je;
    get dataToolTipLabelTextFontFamily(): string;
    set dataToolTipLabelTextFontFamily(a: string);
    private c5;
    get dataToolTipLabelTextFontSize(): number;
    set dataToolTipLabelTextFontSize(a: number);
    private jf;
    get dataToolTipLabelTextFontStyle(): string;
    set dataToolTipLabelTextFontStyle(a: string);
    private jg;
    get dataToolTipLabelTextFontWeight(): string;
    set dataToolTipLabelTextFontWeight(a: string);
    private ae;
    get sortDescriptions(): ChartSortDescriptionDescription[];
    set sortDescriptions(a: ChartSortDescriptionDescription[]);
    private u;
    get groupSortDescriptions(): ChartSortDescriptionDescription[];
    set groupSortDescriptions(a: ChartSortDescriptionDescription[]);
    private t;
    get groupDescriptions(): ChartSortDescriptionDescription[];
    set groupDescriptions(a: ChartSortDescriptionDescription[]);
    private s;
    get filterExpressions(): FilterExpressionDescription[];
    set filterExpressions(a: FilterExpressionDescription[]);
    private af;
    get summaryDescriptions(): ChartSummaryDescriptionDescription[];
    set summaryDescriptions(a: ChartSummaryDescriptionDescription[]);
    private y;
    get initialSortDescriptions(): ChartSortDescriptionDescription[];
    set initialSortDescriptions(a: ChartSortDescriptionDescription[]);
    private x;
    get initialGroupSortDescriptions(): ChartSortDescriptionDescription[];
    set initialGroupSortDescriptions(a: ChartSortDescriptionDescription[]);
    private w;
    get initialGroupDescriptions(): ChartSortDescriptionDescription[];
    set initialGroupDescriptions(a: ChartSortDescriptionDescription[]);
    private z;
    get initialSummaryDescriptions(): ChartSummaryDescriptionDescription[];
    set initialSummaryDescriptions(a: ChartSummaryDescriptionDescription[]);
    private ku;
    get initialSorts(): string;
    set initialSorts(a: string);
    private km;
    get groupSorts(): string;
    set groupSorts(a: string);
    private kt;
    get initialGroups(): string;
    set initialGroups(a: string);
    private kv;
    get initialSummaries(): string;
    set initialSummaries(a: string);
    private iy;
    get dataSourceRef(): string;
    set dataSourceRef(a: string);
    private bb;
    get dataSource(): BaseDataSourceDescription;
    set dataSource(a: BaseDataSourceDescription);
    private v;
    get includedProperties(): string[];
    set includedProperties(a: string[]);
    private r;
    get excludedProperties(): string[];
    set excludedProperties(a: string[]);
    private j;
    get brushes(): string[];
    set brushes(a: string[]);
    private ad;
    get outlines(): string[];
    set outlines(a: string[]);
    private h;
    get actualBrushes(): string[];
    set actualBrushes(a: string[]);
    private i;
    get actualOutlines(): string[];
    set actualOutlines(a: string[]);
    private kz;
    get legendRef(): string;
    set legendRef(a: string);
    private bt;
    get isHorizontalZoomEnabled(): boolean;
    set isHorizontalZoomEnabled(a: boolean);
    private bv;
    get isVerticalZoomEnabled(): boolean;
    set isVerticalZoomEnabled(a: boolean);
    private bx;
    get shouldDisplayMockData(): boolean;
    set shouldDisplayMockData(a: boolean);
    private bz;
    get shouldUseSkeletonStyleForMockData(): boolean;
    set shouldUseSkeletonStyleForMockData(a: boolean);
    private bu;
    get isSeriesHighlightingEnabled(): boolean;
    set isSeriesHighlightingEnabled(a: boolean);
    private bd;
    get windowRect(): RectDescription;
    set windowRect(a: RectDescription);
    private ip;
    get chartTitle(): string;
    set chartTitle(a: string);
    private ld;
    get subtitle(): string;
    set subtitle(a: string);
    private lh;
    get titleAlignment(): string;
    set titleAlignment(a: string);
    private le;
    get subtitleAlignment(): string;
    set subtitleAlignment(a: string);
    private ln;
    get unknownValuePlotting(): string;
    set unknownValuePlotting(a: string);
    private en;
    get resolution(): number;
    set resolution(a: number);
    private et;
    get thickness(): number;
    set thickness(a: number);
    private k3;
    get outlineMode(): string;
    set outlineMode(a: string);
    private k2;
    get markerOutlineMode(): string;
    set markerOutlineMode(a: string);
    private k1;
    get markerFillMode(): string;
    set markerFillMode(a: string);
    private eg;
    get markerFillOpacity(): number;
    set markerFillOpacity(a: number);
    private eh;
    get markerThickness(): number;
    set markerThickness(a: number);
    private ac;
    get markerTypes(): string[];
    set markerTypes(a: string[]);
    private k0;
    get markerAutomaticBehavior(): string;
    set markerAutomaticBehavior(a: string);
    private aa;
    get markerBrushes(): string[];
    set markerBrushes(a: string[]);
    private ab;
    get markerOutlines(): string[];
    set markerOutlines(a: string[]);
    private h5;
    get markerMaxCount(): number;
    set markerMaxCount(a: number);
    private cn;
    get areaFillOpacity(): number;
    set areaFillOpacity(a: number);
    private bg;
    get animateSeriesWhenAxisRangeChanges(): boolean;
    set animateSeriesWhenAxisRangeChanges(a: boolean);
    private ag;
    get trendLineBrushes(): string[];
    set trendLineBrushes(a: string[]);
    private lm;
    get trendLineType(): string;
    set trendLineType(a: string);
    private ez;
    get trendLineThickness(): number;
    set trendLineThickness(a: number);
    private bf;
    get alignsGridLinesToPixels(): boolean;
    set alignsGridLinesToPixels(a: boolean);
    private ek;
    get plotAreaMarginLeft(): number;
    set plotAreaMarginLeft(a: number);
    private em;
    get plotAreaMarginTop(): number;
    set plotAreaMarginTop(a: number);
    private el;
    get plotAreaMarginRight(): number;
    set plotAreaMarginRight(a: number);
    private ej;
    get plotAreaMarginBottom(): number;
    set plotAreaMarginBottom(a: number);
    private iq;
    get computedPlotAreaMarginMode(): string;
    set computedPlotAreaMarginMode(a: string);
    private k5;
    get seriesPlotAreaMarginHorizontalMode(): string;
    set seriesPlotAreaMarginHorizontalMode(a: string);
    private k6;
    get seriesPlotAreaMarginVerticalMode(): string;
    set seriesPlotAreaMarginVerticalMode(a: string);
    private ko;
    get highlightingMode(): string;
    set highlightingMode(a: string);
    private kn;
    get highlightingBehavior(): string;
    set highlightingBehavior(a: string);
    private kw;
    get legendHighlightingMode(): string;
    set legendHighlightingMode(a: string);
    private ky;
    get legendItemBadgeShape(): string;
    set legendItemBadgeShape(a: string);
    private kx;
    get legendItemBadgeMode(): string;
    set legendItemBadgeMode(a: string);
    private h7;
    get trendLinePeriod(): number;
    set trendLinePeriod(a: number);
    private lk;
    get toolTipType(): string;
    set toolTipType(a: string);
    private iv;
    get crosshairsDisplayMode(): string;
    set crosshairsDisplayMode(a: string);
    private bl;
    get crosshairsSnapToData(): boolean;
    set crosshairsSnapToData(a: boolean);
    private ix;
    get crosshairsLineVerticalStroke(): string;
    set crosshairsLineVerticalStroke(a: string);
    private cp;
    get crosshairsLineThickness(): number;
    set crosshairsLineThickness(a: number);
    private iw;
    get crosshairsLineHorizontalStroke(): string;
    set crosshairsLineHorizontalStroke(a: string);
    private bk;
    get crosshairsAnnotationEnabled(): boolean;
    set crosshairsAnnotationEnabled(a: boolean);
    private ir;
    get crosshairsAnnotationXAxisBackground(): string;
    set crosshairsAnnotationXAxisBackground(a: string);
    private it;
    get crosshairsAnnotationYAxisBackground(): string;
    set crosshairsAnnotationYAxisBackground(a: string);
    private is;
    get crosshairsAnnotationXAxisTextColor(): string;
    set crosshairsAnnotationXAxisTextColor(a: string);
    private iu;
    get crosshairsAnnotationYAxisTextColor(): string;
    set crosshairsAnnotationYAxisTextColor(a: string);
    private h0;
    get crosshairsAnnotationXAxisPrecision(): number;
    set crosshairsAnnotationXAxisPrecision(a: number);
    private h1;
    get crosshairsAnnotationYAxisPrecision(): number;
    set crosshairsAnnotationYAxisPrecision(a: number);
    private bw;
    get shouldAvoidAxisAnnotationCollisions(): boolean;
    set shouldAvoidAxisAnnotationCollisions(a: boolean);
    private by;
    get shouldPanOnMaximumZoom(): boolean;
    set shouldPanOnMaximumZoom(a: boolean);
    private br;
    get finalValueAnnotationsVisible(): boolean;
    set finalValueAnnotationsVisible(a: boolean);
    private kk;
    get finalValueAnnotationsBackground(): string;
    set finalValueAnnotationsBackground(a: string);
    private kl;
    get finalValueAnnotationsTextColor(): string;
    set finalValueAnnotationsTextColor(a: string);
    private h4;
    get finalValueAnnotationsPrecision(): number;
    set finalValueAnnotationsPrecision(a: number);
    private bh;
    get autoCalloutsVisible(): boolean;
    set autoCalloutsVisible(a: boolean);
    private bj;
    get calloutsVisible(): boolean;
    set calloutsVisible(a: boolean);
    private bi;
    get calloutStyleUpdatingEventEnabled(): boolean;
    set calloutStyleUpdatingEventEnabled(a: boolean);
    private ij;
    get calloutsDataSourceRef(): string;
    set calloutsDataSourceRef(a: string);
    private k;
    get calloutsAllowedPositions(): string[];
    set calloutsAllowedPositions(a: string[]);
    private im;
    get calloutsXMemberPath(): string;
    set calloutsXMemberPath(a: string);
    private io;
    get calloutsYMemberPath(): string;
    set calloutsYMemberPath(a: string);
    private ik;
    get calloutsLabelMemberPath(): string;
    set calloutsLabelMemberPath(a: string);
    private ii;
    get calloutsContentMemberPath(): string;
    set calloutsContentMemberPath(a: string);
    private ah;
    get valueLines(): string[];
    set valueLines(a: string[]);
    private ai;
    get valueLinesBrushes(): string[];
    set valueLinesBrushes(a: string[]);
    private e0;
    get valueLinesThickness(): number;
    set valueLinesThickness(a: number);
    private kq;
    get horizontalViewScrollbarMode(): string;
    set horizontalViewScrollbarMode(a: string);
    private lp;
    get verticalViewScrollbarMode(): string;
    set verticalViewScrollbarMode(a: string);
    private ks;
    get horizontalViewScrollbarPosition(): string;
    set horizontalViewScrollbarPosition(a: string);
    private lr;
    get verticalViewScrollbarPosition(): string;
    set verticalViewScrollbarPosition(a: string);
    private kp;
    get horizontalViewScrollbarFill(): string;
    set horizontalViewScrollbarFill(a: string);
    private kr;
    get horizontalViewScrollbarOutline(): string;
    set horizontalViewScrollbarOutline(a: string);
    private ec;
    get horizontalViewScrollbarStrokeThickness(): number;
    set horizontalViewScrollbarStrokeThickness(a: number);
    private eb;
    get horizontalViewScrollbarMaxOpacity(): number;
    set horizontalViewScrollbarMaxOpacity(a: number);
    private d8;
    get horizontalViewScrollbarCornerRadius(): number;
    set horizontalViewScrollbarCornerRadius(a: number);
    private d9;
    get horizontalViewScrollbarHeight(): number;
    set horizontalViewScrollbarHeight(a: number);
    private ea;
    get horizontalViewScrollbarInset(): number;
    set horizontalViewScrollbarInset(a: number);
    private ee;
    get horizontalViewScrollbarTrackStartInset(): number;
    set horizontalViewScrollbarTrackStartInset(a: number);
    private ed;
    get horizontalViewScrollbarTrackEndInset(): number;
    set horizontalViewScrollbarTrackEndInset(a: number);
    private bs;
    get horizontalViewScrollbarShouldAddAutoTrackInsets(): boolean;
    set horizontalViewScrollbarShouldAddAutoTrackInsets(a: boolean);
    private lo;
    get verticalViewScrollbarFill(): string;
    set verticalViewScrollbarFill(a: string);
    private lq;
    get verticalViewScrollbarOutline(): string;
    set verticalViewScrollbarOutline(a: string);
    private e4;
    get verticalViewScrollbarStrokeThickness(): number;
    set verticalViewScrollbarStrokeThickness(a: number);
    private e3;
    get verticalViewScrollbarMaxOpacity(): number;
    set verticalViewScrollbarMaxOpacity(a: number);
    private e1;
    get verticalViewScrollbarCornerRadius(): number;
    set verticalViewScrollbarCornerRadius(a: number);
    private e7;
    get verticalViewScrollbarWidth(): number;
    set verticalViewScrollbarWidth(a: number);
    private e2;
    get verticalViewScrollbarInset(): number;
    set verticalViewScrollbarInset(a: number);
    private e6;
    get verticalViewScrollbarTrackStartInset(): number;
    set verticalViewScrollbarTrackStartInset(a: number);
    private e5;
    get verticalViewScrollbarTrackEndInset(): number;
    set verticalViewScrollbarTrackEndInset(a: number);
    private b0;
    get verticalViewScrollbarShouldAddAutoTrackInsets(): boolean;
    set verticalViewScrollbarShouldAddAutoTrackInsets(a: boolean);
    private e9;
    get windowRectMinWidth(): number;
    set windowRectMinWidth(a: number);
    private e8;
    get windowRectMinHeight(): number;
    set windowRectMinHeight(a: number);
    private fb;
    get windowSizeMinWidth(): number;
    set windowSizeMinWidth(a: number);
    private fa;
    get windowSizeMinHeight(): number;
    set windowSizeMinHeight(a: number);
    private k4;
    get seriesAddedRef(): string;
    set seriesAddedRef(a: string);
    private lc;
    get seriesRemovedRef(): string;
    set seriesRemovedRef(a: string);
    private k8;
    get seriesPointerEnterRef(): string;
    set seriesPointerEnterRef(a: string);
    private k9;
    get seriesPointerLeaveRef(): string;
    set seriesPointerLeaveRef(a: string);
    private la;
    get seriesPointerMoveRef(): string;
    set seriesPointerMoveRef(a: string);
    private k7;
    get seriesPointerDownRef(): string;
    set seriesPointerDownRef(a: string);
    private lb;
    get seriesPointerUpRef(): string;
    set seriesPointerUpRef(a: string);
    private il;
    get calloutStyleUpdatingRef(): string;
    set calloutStyleUpdatingRef(a: string);
    private ih;
    get calloutRenderStyleUpdatingRef(): string;
    set calloutRenderStyleUpdatingRef(a: string);
}
