import { Type } from "./type";
/**
 * Identifies the type of wrapper expression.
 */
export declare enum FilterExpressionWrapperType {
    /**
     * A wrapper for the Today expression.
     */
    Today = 0,
    /**
     * A wrapper for the Tomorrow expression.
     */
    Tomorrow = 1,
    /**
     * A wrapper for the Yesterday expression.
     */
    Yesterday = 2,
    /**
     * A wrapper for the ThisWeek expression.
     */
    ThisWeek = 3,
    /**
     * A wrapper for the NextWeek expression.
     */
    NextWeek = 4,
    /**
     * A wrapper for the LastWeek expression.
     */
    LastWeek = 5,
    /**
     * A wrapper for the ThisMonth expression.
     */
    ThisMonth = 6,
    /**
     * A wrapper for the NextMonth expression.
     */
    NextMonth = 7,
    /**
     * A wrapper for the LastMonth expression.
     */
    LastMonth = 8,
    /**
     * A wrapper for the ThisYear expression.
     */
    ThisYear = 9,
    /**
     * A wrapper for the NextYear expression.
     */
    NextYear = 10,
    /**
     * A wrapper for the LastYear expression.
     */
    LastYear = 11,
    /**
     * A wrapper for the ThisQuarter expression.
     */
    ThisQuarter = 12,
    /**
     * A wrapper for the NextQuarter expression.
     */
    NextQuarter = 13,
    /**
     * A wrapper for the LastQuarter expression.
     */
    LastQuarter = 14,
    /**
     * A wrapper for the YearToDate expression.
     */
    YearToDate = 15,
    /**
     * A wrapper for the Q1 expression.
     */
    Q1 = 16,
    /**
     * A wrapper for the Q2 expression.
     */
    Q2 = 17,
    /**
     * A wrapper for the Q3 expression.
     */
    Q3 = 18,
    /**
     * A wrapper for the Q4 expression.
     */
    Q4 = 19
}
/**
 * @hidden
 */
export declare let FilterExpressionWrapperType_$type: Type;
