import { Type } from "./type";
/**
 * Describes mode of legend badges that represent all series in a legend
 */
export declare enum LegendItemBadgeMode {
    /**
     * Specifies legend badges with simplified visuals of series, e.g. with fixed thickness, no overlaid markers
     */
    Simplified = 0,
    /**
     * Specifies legend badges that match all visuals of series such as thickness and markers (if supported by a series)
     */
    MatchSeries = 1
}
/**
 * @hidden
 */
export declare let LegendItemBadgeMode_$type: Type;
