import { Type } from "./type";
/**
 * Indicates which side of the exclusion rectangle to which the popup is aligned.
 */
export declare enum PopupAlignment {
    /**
     * No specified direction.
     */
    Auto = 0,
    /**
     * Popup should be aligned to the near side. This usually means left or top.
     */
    Near = 1,
    /**
     * Popup should be aligned to the near far. This usually means right or bottom.
     */
    Far = 2,
    /**
     * Popup should be aligned in the middle.
     */
    Middle = 3
}
/**
 * @hidden
 */
export declare let PopupAlignment_$type: Type;
