import { Type } from "./type";
/**
 * Indicates which direction the popup will pop up in relation to the exclusion rectangle.
 */
export declare enum PopupDirection {
    /**
     * No specified direction.
     */
    Auto = 0,
    /**
     * Popup should be displayed downward.
     */
    Down = 1,
    /**
     * Popup should be displayed upward.
     */
    Up = 2,
    /**
     * Popup should be displayed to the left.
     */
    Left = 3,
    /**
     * Popup should be displayed to the right.
     */
    Right = 4
}
/**
 * @hidden
 */
export declare let PopupDirection_$type: Type;
