import { Type } from "./type";
/**
 * Describes the different types of scrollbars available.
 */
export declare enum ScrollbarStyle {
    /**
     * The default scrollbar style.
     */
    Default = 0,
    /**
     * The scrollbar will fade away after a few seconds when the mouse moves away from it or scrolling stops.
     */
    Fading = 1,
    /**
     * The scrollbar appears as a thin line when idle. It will grow in size when scrolling or when the mouse is close by.
     */
    Thin = 2
}
/**
 * @hidden
 */
export declare let ScrollbarStyle_$type: Type;
