import { IDataSourceSchema } from "./IDataSourceSchema";
import { DataSourceSchemaChangedEventArgs as DataSourceSchemaChangedEventArgs_internal } from "./DataSourceSchemaChangedEventArgs";
import { ContentChildrenManager } from "./ContentChildrenManager";
/**
 * Provides information about a schema change event that has occurred.
*/
export declare class IgrDataSourceSchemaChangedEventArgs {
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): DataSourceSchemaChangedEventArgs_internal;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the new schema that has been provided.
    */
    get schema(): IDataSourceSchema;
    /**
     * Gets the current full count of items in the data source.
    */
    get count(): number;
}
